
#include <glut.h>
#include "3DGraphics.h"

#pragma comment(lib,"3DGraphics.lib")


const GLint sizeV1=4;
const GLint sizeF1=2;
GLfloat texCoords1[sizeV1][2]={{0.0f, 0.0f},
							{1.0f, 0.0f},
							{1.0f, 1.0f},
							{0.0f, 1.0f}};

GLfloat normals1[sizeF1*3][3];

GLfloat vertices1[sizeV1][3]={{-0.5f, -0.5f, 0.5f},	
							{ 0.5f, -0.5f, 0.5f},
							{0.5f, -0.5f, -0.5f},
							{-0.5f, -0.5f, -0.5f}};

short face_indicies1[sizeF1][9]= {{0,1,2, 0,0,0, 0,1,2},
								{3,0,2, 1,1,1, 3,0,2}}; 

  
const GLint numTextures = 1;

unsigned int		textureNames[numTextures];	// the texture objects

char *fileNames[numTextures]={"checker.bmp"}; 




void display(void);
void keyboard(unsigned char, int, int); 
void special(int, int, int);

void drawScene ()
{
   Draw3DTextureObject(face_indicies1, normals1, vertices1, texCoords1, sizeF1, textureNames[0]);
}


void display()
{
    glClearColor(0.0, 0.0, 0.0, 0.0);
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);		
	glLoadIdentity();

	navigate();

	glPushMatrix();
 
//	 glTranslatef(0.0, 0.0, -2.0);

     glRotatef(angleViewX, 1.0, 0.0, 0.0);
     glRotatef(angleViewY, 0.0, 1.0, 0.0);

     drawScene ();

	glPopMatrix();

	glFlush();
	glutSwapBuffers();
}


void keyboard(unsigned char key, int x, int y)
{
	if( key == 27 ) { 	
	  exit(0);
	}

    glutPostRedisplay();
}


void special(int key, int x, int y)
{
  GLfloat x1=0.0, y1=0.0, z1=0.0, del = 0.01; 

	if (key==GLUT_KEY_HOME)
	{
		angleViewX = 0.0;
		angleViewY = 0.0;
	}

	if (key==GLUT_KEY_LEFT)
	{
      x1 = del*(-1);
	}
	if (key==GLUT_KEY_RIGHT)
	{
      x1 = del;
	}
	if (key==GLUT_KEY_UP)
	{
      z1 = del*(-1); 
	}
	if (key==GLUT_KEY_DOWN)
	{
      z1 = del;
	}
	if (key==GLUT_KEY_PAGE_DOWN)
	{
      y1 = del*(-1); 
	}
	if (key==GLUT_KEY_PAGE_UP)
	{
      y1 = del;
	}

    navigateUpdate(x1, y1, z1);

	glutPostRedisplay();
}
/*----------*/


void main (int argc, char **argv)
{
    glutInit(&argc, argv);
	init();
	initTexture(textureNames,fileNames, numTextures);

    glutDisplayFunc(display);
	glutKeyboardFunc(keyboard);
    glutSpecialFunc(special);
    glutMainLoop();
}
